<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow(); openModal(modal);" class="btn btn-primary">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <div *ngIf="!loading">

      <kendo-grid [data]="dataGrid.data" [filter]="filter" [filterable]="false" (filterChange)="filterChange($event)"
                  [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort"
                  [sortable]="true" (sortChange)="sortChange($event)" [groupable]="true" [group]="groups"
                  (groupChange)="groupChange($event)" style="height: 75vh">
          <ng-template kendoGridToolbarTemplate>
            <button type="button" kendoGridExcelCommand icon="file-excel" [disabled]="dataGrid.data.length === 0"
             class="btn-success">Exportar Excel</button>
          </ng-template>
        <kendo-grid-column field="Punto" title="Punto" width="100">
        </kendo-grid-column>
        <kendo-grid-column field="Turno" title="Turno" width="100">
        </kendo-grid-column>
        <kendo-grid-column field="tdesc" title="Descripción">
        </kendo-grid-column>
        <kendo-grid-command-column title="Actions" width="190">
          <ng-template kendoGridCellTemplate let-isNew="isNew" let-dataItem>
            <button kendoGridEditCommand class="k-button" [primary]="true"
                    (click)="editRow(dataItem); openModal(modal);">
              Editar
            </button>
            <button type="button" class="k-button" (click)="deleteRow(dataItem)">
              Eliminar
            </button>
          </ng-template>
        </kendo-grid-command-column>
        <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
      </kendo-grid>

    </div>
<app-loading *ngIf="loading"></app-loading>

    <ng-template #modal let-c="close" let-d="dismiss">
      <form [formGroup]="myFormGroup">
        <div class="modal-body row-fluid p-3">
          <fieldset>
            <legend *ngIf="!flagEdit">Nuevo Turno</legend>
            <legend *ngIf="flagEdit">Actualizar Turno</legend>
          </fieldset>
          <div class="row">
            <label class="k-form-field col-4">
              <span>Punto</span>
              <kendo-combobox [data]="dsPuntos" [textField]="'pdesc'" [valueField]="'Punto'"
                              [filterable]="true" [valuePrimitive]="true" (filterChange)="puntoFilter($event)"
                              formControlName="Punto" class="w-100">
              </kendo-combobox>
            </label>
            <label class="k-form-field col-2">
              <span>Turno</span>
              <input type="number" class="form-control" formControlName="Turno" min="0" max="999">
            </label>
            <label class="k-form-field col-6">
              <span>Descripción</span>
              <input type="text" class="form-control" formControlName="tdesc" maxlength="30">
            </label>
          </div>
          <hr>
          <legend>Clases x Turno</legend>
          <div class="row">
            <app-clases-turnos [data]="myFormGroup.value"></app-clases-turnos>
          </div>
        </div>
        <div class="modal-footer pt-2">
          <button type="button" class="btn btn-shadow btn-primary px-4 py-2"
                  (click)="c('Close click'); closeForm();">
            Cerrar
          </button>
          <button type="button" class="btn btn-shadow btn-success ml-1 px-4 py-2"
                  [disabled]="myFormGroup.invalid" (click)="guardarForm(); c()">
            <i class="fas fa-save mr-2"></i> Guardar
          </button>
        </div>
      </form>
    </ng-template>
  </div>
</div>
